var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __decorateClass = (decorators, target, key, kind) => {
  var result = kind > 1 ? void 0 : kind ? __getOwnPropDesc(target, key) : target;
  for (var i = decorators.length - 1, decorator; i >= 0; i--)
    if (decorator = decorators[i])
      result = (kind ? decorator(target, key, result) : decorator(result)) || result;
  if (kind && result)
    __defProp(target, key, result);
  return result;
};

// src/mailer.ts
var mailer_exports = {};
__export(mailer_exports, {
  MailDelivery: () => MailDelivery,
  Mailer: () => Mailer
});
module.exports = __toCommonJS(mailer_exports);
var import_nodemailer = __toESM(require("nodemailer"));
var import_debug2 = __toESM(require("debug"));
var import_nodemailer_stub = require("nodemailer-stub");

// src/worker.ts
var import_reflect_metadata = require("reflect-metadata");
var import_debug = __toESM(require("debug"));
var debug = (0, import_debug.default)("hyperworker:worker");
var K_QUEUE_NAME = "hyperworker:queue-name";
var K_PRODUCER_ONLY = "hyperworker:queue-producer-only";
var queueAs = (queueName) => (target) => {
  return Reflect.defineMetadata(K_QUEUE_NAME, queueName, target);
};
var _HyperWorker = class {
  static clear() {
    this.logger = null;
    this.backend = null;
    this.inprocess = false;
    this.enqueue = null;
    this.reportError = (_err, _tags) => {
    };
  }
  static initWorker({ logger }) {
    this.logger = logger;
  }
  static setMode({
    inprocess,
    reportError
  }) {
    this.inprocess = inprocess;
    if (reportError) {
      this.reportError = reportError;
    }
  }
  static setTest(reportError) {
    this.setMode({ inprocess: true, reportError });
  }
  static get queueName() {
    return Reflect.getOwnMetadata(K_QUEUE_NAME, this) || this.name.toLowerCase();
  }
  static get producerOnly() {
    return Reflect.getOwnMetadata(K_PRODUCER_ONLY, this) || false;
  }
  static async performNow(args) {
    const w = new this();
    return w.perform({ data: args });
  }
  static async performLater(_args) {
    if (this.inprocess) {
      debug(`${this.name}: perform now '%o'`, _args);
      return this.performNow(_args);
    }
    debug(`${this.name}: perform later '%o'`, _args);
    return this.enqueue(_args, {});
  }
  static async jobCounts() {
    return await this.queue.getJobCounts();
  }
  get logger() {
    return _HyperWorker.logger;
  }
  perform(_args) {
  }
};
var HyperWorker = _HyperWorker;
HyperWorker.inprocess = false;
HyperWorker.logger = null;
HyperWorker.backend = null;
HyperWorker.enqueue = null;
HyperWorker.queue = null;
HyperWorker.reportError = (_err, _tags) => {
};

// src/mailer.ts
var debug2 = (0, import_debug2.default)("hyperworker:mailer");
var MailDelivery = class {
  constructor(MailerType, details) {
    this.MailerType = MailerType;
    this.details = details;
  }
  async deliver() {
    if (!HyperWorker.logger) {
      throw new Error("Logger is not configured. Did the app boot correctly?");
    }
    const { cyan, bold } = HyperWorker.logger.colors;
    const pref = bold(cyan("mailers:"));
    HyperWorker.logger.info(`${pref} ${this.MailerType.name} delivering`, this.details);
    return this.MailerType.performNow(this.details);
  }
  async deliverLater() {
    if (!HyperWorker.logger) {
      throw new Error("Logger is not configured. Did the app boot correctly?");
    }
    const { cyan, bold } = HyperWorker.logger.colors;
    const pref = bold(cyan("mailers:"));
    HyperWorker.logger.info(`${pref} ${this.MailerType.name} delivering later`, this.details);
    return this.MailerType.performLater(this.details);
  }
};
var Mailer = class extends HyperWorker {
  static clearDeliveries() {
    import_nodemailer_stub.interactsWithMail.flushMails();
  }
  static deliveries() {
    return import_nodemailer_stub.interactsWithMail.mails;
  }
  static lastMail() {
    return import_nodemailer_stub.interactsWithMail.lastMail();
  }
  static clear() {
    this.transport = null;
    this.send = false;
    this.preview = false;
    this.templatesRoot = null;
  }
  static initMailer({
    templatesRoot,
    settings
  }) {
    this.templatesRoot = templatesRoot;
    if (settings) {
      this.send = !!settings.send;
      this.preview = !!settings.preview;
      if (settings.delivery === "test") {
        this.transport = import_nodemailer_stub.stubTransport;
      } else if (settings.delivery === "smtp") {
        this.transport = import_nodemailer.default.createTransport(settings.smtpSettings);
      }
    }
  }
  static setNone() {
    this.send = false;
    this.preview = false;
    this.transport = null;
  }
  static setTest() {
    this.send = true;
    this.preview = false;
    this.transport = import_nodemailer_stub.stubTransport;
  }
  static setDevelopment() {
    this.send = false;
    this.preview = true;
    this.transport = null;
  }
  static setProduction() {
    this.send = true;
    this.preview = false;
  }
  async perform({ data }) {
    if (!HyperWorker.logger) {
      throw new Error("Logger is not configured. Did the app boot correctly?");
    }
    if (!Mailer.templatesRoot) {
      throw new Error("please set Mailer.templatesRoot");
    }
    const Email = require("email-templates");
    debug2(`mailer: send settings '%o'`, {
      send: Mailer.send,
      preview: Mailer.preview
    });
    const tmpl = new Email({
      views: { root: Mailer.templatesRoot, options: { extension: "ejs" } },
      transport: Mailer.transport || { jsonTransport: true },
      send: Mailer.send,
      preview: Mailer.preview,
      juice: false
    });
    try {
      debug2(`mailer: perform '%o'`, data);
      const res = await tmpl.send(data);
      const { cyan, bold } = HyperWorker.logger.colors;
      const pref = bold(cyan("mailers:"));
      HyperWorker.logger.info(`${pref} delivered email to: ${data.message.to}`, res);
      return res;
    } catch (e) {
      HyperWorker.logger.error(e);
      HyperWorker.reportError(e);
    }
  }
  static mail(details, _opts = {}) {
    details.message = __spreadValues(__spreadValues({}, this.defaults), details.message);
    return new MailDelivery(this, details);
  }
  get logger() {
    return HyperWorker.logger;
  }
};
Mailer.transport = null;
Mailer.send = false;
Mailer.preview = false;
Mailer.templatesRoot = null;
Mailer.defaults = {
  from: "Joe <mailer@example.com>"
};
Mailer = __decorateClass([
  queueAs("mails")
], Mailer);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  MailDelivery,
  Mailer
});
