import * as _hyperstackjs_typings from '@hyperstackjs/typings';
import { MailerSettings, WorkerBackendOpts, Logger } from '@hyperstackjs/typings';
import { BullmqBackend, JobCounts } from './backend.js';

declare class MailDelivery {
    private MailerType;
    private details;
    constructor(MailerType: typeof Mailer, details: any);
    deliver(): Promise<any>;
    deliverLater(): Promise<any>;
}
declare class Mailer extends HyperWorker {
    static transport: any | null;
    static send: boolean;
    static preview: boolean;
    static templatesRoot: string | null;
    static clearDeliveries(): void;
    static deliveries(): any;
    static lastMail(): any;
    static clear(): void;
    static defaults: {
        from: string;
    };
    static initMailer({ templatesRoot, settings, }: {
        templatesRoot: string;
        settings: MailerSettings;
    }): void;
    static setNone(): void;
    static setTest(): void;
    static setDevelopment(): void;
    static setProduction(): void;
    perform({ data }: any): Promise<any>;
    static mail(details: any, _opts?: any): MailDelivery;
    get logger(): _hyperstackjs_typings.Logger | null;
}

interface Worker {
    perform(args: any): any;
}
interface WorkerTypes {
    HyperWorker: typeof HyperWorker;
    Mailer: typeof Mailer;
}
interface LoadWorkersOpts {
    workersGlob: string;
    mailersGlob: string;
}
interface CreateWorkerConnectionOpts {
    redisUrl: string;
    rejectUnauthorized?: boolean;
}
interface BuildWorkersParams {
    isInProcess: boolean;
    workersGlob: string;
    mailersGlob: string;
    mailerTemplatesRoot: string;
    mailerSettings?: MailerSettings;
    logger: any;
    redisUrl?: string;
    backendOpts?: WorkerBackendOpts;
    truncate?: boolean;
    beforeWorkers?: (_p: any) => void;
    afterWorkers?: (_p: any) => void;
}

declare const queueAs: (queueName: string) => (target: Object) => void;
declare const producerOnly: () => (target: Object) => void;
declare class HyperWorker implements Worker {
    static inprocess: boolean;
    static logger: Logger | null;
    static backend: BullmqBackend | null;
    static enqueue: any;
    static queue: any;
    static reportError: (_err: Error, _tags?: any) => void;
    static clear(): void;
    static initWorker({ logger }: any): void;
    static setMode({ inprocess, reportError, }: {
        inprocess: boolean;
        reportError?: (err: Error, tags?: any) => void;
    }): void;
    static setTest(reportError: any): void;
    static get queueName(): any;
    static get producerOnly(): any;
    static performNow(args: any): Promise<any>;
    static performLater(_args: any): Promise<any>;
    static jobCounts(): Promise<JobCounts>;
    get logger(): Logger | null;
    perform(_args: any): any;
}

export { BuildWorkersParams as B, CreateWorkerConnectionOpts as C, HyperWorker as H, LoadWorkersOpts as L, Mailer as M, Worker as W, WorkerTypes as a, MailDelivery as b, producerOnly as p, queueAs as q };
